'use strict';Object.defineProperty(exports,"__esModule",{value:true});var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source){if(Object.prototype.hasOwnProperty.call(source,key)){target[key]=source[key];}}}return target;};var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;if("value"in descriptor)descriptor.writable=true;Object.defineProperty(target,descriptor.key,descriptor);}}return function(Constructor,protoProps,staticProps){if(protoProps)defineProperties(Constructor.prototype,protoProps);if(staticProps)defineProperties(Constructor,staticProps);return Constructor;};}();var _jsxFileName='src/SlideVerify/index.js';var _react=require('react');var _react2=_interopRequireDefault(_react);var _propTypes=require('prop-types');var _propTypes2=_interopRequireDefault(_propTypes);var _reactNative=require('react-native');var _Feather=require('react-native-vector-icons/Feather');var _Feather2=_interopRequireDefault(_Feather);var _Ionicons=require('react-native-vector-icons/Ionicons');var _Ionicons2=_interopRequireDefault(_Ionicons);var _reactNativeCachedImage=require('react-native-cached-image');var _styles=require('./styles');var _styles2=_interopRequireDefault(_styles);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj};}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor)){throw new TypeError("Cannot call a class as a function");}}function _possibleConstructorReturn(self,call){if(!self){throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return call&&(typeof call==="object"||typeof call==="function")?call:self;}function _inherits(subClass,superClass){if(typeof superClass!=="function"&&superClass!==null){throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);}subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});if(superClass)Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass;}var defaultPuzzle={puzzle:require('../images/puzzle.jpg'),puzzlePiece:require('../images/puzzlePiece.png'),pieceOffsetX:79,allowableOffsetError:3};var generateSlidingStyles=function generateSlidingStyles(iconName){var iconColor=arguments.length>1&&arguments[1]!==undefined?arguments[1]:'white';var buttonColor=arguments[2];var borderColor=arguments.length>3&&arguments[3]!==undefined?arguments[3]:buttonColor;var indicatorColor=arguments[4];return{icon:_react2.default.createElement(_Feather2.default,{name:iconName,size:25,color:iconColor,__source:{fileName:_jsxFileName,lineNumber:36}}),buttonColor:buttonColor,borderColor:borderColor,indicatorColor:indicatorColor};};var slidingStyles={READY:generateSlidingStyles('arrow-right','#5C6167','white','#e4e7eb','#e4e7eb'),MOVING:generateSlidingStyles('arrow-right',undefined,'#1991fa',undefined,'#d1e9fe'),VERIFY_PASS:generateSlidingStyles('check',undefined,'#52ccba',undefined,'#d2f4ef'),VERIFY_FAIL:generateSlidingStyles('x',undefined,'#f57a7a',undefined,'#fce1e1')};var SlideVerification=function(_Component){_inherits(SlideVerification,_Component);function SlideVerification(){var _ref,_this2=this;var _temp,_this,_ret;_classCallCheck(this,SlideVerification);for(var _len=arguments.length,args=Array(_len),_key=0;_key<_len;_key++){args[_key]=arguments[_key];}return _ret=(_temp=(_this=_possibleConstructorReturn(this,(_ref=SlideVerification.__proto__||Object.getPrototypeOf(SlideVerification)).call.apply(_ref,[this].concat(args))),_this),_this.state={offsetXAnim:new _reactNative.Animated.Value(0),slideStatus:slidingStyles.READY,moving:false,verifying:false,result:null,lastResult:null},_this.hanldeShouldBeResponder=function(){return _this.state.lastResult!==true&&!_this.state.moving;},_this.handlePanResponderGrant=function(){return _this.setState({moving:true,result:null,slideStatus:slidingStyles.MOVING});},_this.handlePanResponderMove=function(){var offsetXAnim=_this.state.offsetXAnim;var _this$props$imageSize=_this.props.imageSize,puzzleWidth=_this$props$imageSize.puzzleWidth,puzzlePieceWidth=_this$props$imageSize.puzzlePieceWidth;var maxMoving=puzzleWidth-puzzlePieceWidth;return _reactNative.Animated.event([null,{dx:offsetXAnim}],{listener:function listener(event,gestureState){if(gestureState.dx<0){offsetXAnim.setValue(0);}else if(gestureState.dx>maxMoving){offsetXAnim.setValue(maxMoving);}}});},_this.handlePanResponderRelease=function _callee(event,gestureState){var offset,pieceOffsetX,allowableOffsetError,minOffsetX,maxOffsetX,slideVerify;return regeneratorRuntime.async(function _callee$(_context){while(1){switch(_context.prev=_context.next){case 0:offset=gestureState.dx;if(!_this.props.useDefault){_context.next=8;break;}pieceOffsetX=defaultPuzzle.pieceOffsetX,allowableOffsetError=defaultPuzzle.allowableOffsetError;minOffsetX=pieceOffsetX-allowableOffsetError;maxOffsetX=pieceOffsetX+allowableOffsetError;offset>=minOffsetX&&offset<=maxOffsetX?_this.handleVerifyPassed():_this.handleVerifyFailed();_context.next=21;break;case 8:slideVerify=_this.props.slideVerify;if(!slideVerify){_context.next=21;break;}_this.setState({verifying:true});_context.prev=11;_context.next=14;return regeneratorRuntime.awrap(slideVerify(offset));case 14:_this.handleVerifyPassed();_context.next=20;break;case 17:_context.prev=17;_context.t0=_context['catch'](11);_this.handleVerifyFailed();case 20:_this.setState({verifying:false});case 21:case'end':return _context.stop();}}},null,_this2,[[11,17]]);},_this.handleVerifyPassed=function(){var _this$props=_this.props,useDefault=_this$props.useDefault,onVerifyPassed=_this$props.onVerifyPassed;_this.setState({moving:false,result:true,slideStatus:slidingStyles.VERIFY_PASS,lastResult:true});useDefault&&onVerifyPassed&&onVerifyPassed();},_this.handleVerifyFailed=function(){var _this$props2=_this.props,useDefault=_this$props2.useDefault,onVerifyFailed=_this$props2.onVerifyFailed;_this.setState({result:false,slideStatus:slidingStyles.VERIFY_FAIL});useDefault&&onVerifyFailed&&onVerifyFailed();_reactNative.Animated.timing(_this.state.offsetXAnim,{toValue:0,delay:500,easing:_reactNative.Easing.linear}).start(function(){_this.setState({slideStatus:slidingStyles.READY,moving:false,result:null,lastResult:false});});},_temp),_possibleConstructorReturn(_this,_ret);}_createClass(SlideVerification,[{key:'componentWillMount',value:function componentWillMount(){this.panResponder=_reactNative.PanResponder.create({onStartShouldSetPanResponder:this.hanldeShouldBeResponder,onStartShouldSetPanResponderCapture:this.hanldeShouldBeResponder,onMoveShouldSetPanResponder:this.hanldeShouldBeResponder,onMoveShouldSetPanResponderCapture:this.hanldeShouldBeResponder,onPanResponderGrant:this.handlePanResponderGrant,onPanResponderMove:this.handlePanResponderMove(),onPanResponderRelease:this.handlePanResponderRelease});}},{key:'render',value:function render(){var _props=this.props,useDefault=_props.useDefault,_props$imageSize=_props.imageSize,puzzleWidth=_props$imageSize.puzzleWidth,puzzleHeight=_props$imageSize.puzzleHeight,puzzlePieceWidth=_props$imageSize.puzzlePieceWidth,showRefresh=_props.showRefresh,refresh=_props.refresh,displayType=_props.displayType,slideTips=_props.slideTips;var puzzle=void 0;var puzzlePiece=void 0;if(useDefault){var _state=this.state;puzzle=_state.puzzle;puzzlePiece=_state.puzzlePiece;}else{var _props2=this.props;puzzle=_props2.puzzle;puzzlePiece=_props2.puzzlePiece;}var _state2=this.state,slideStatus=_state2.slideStatus,moving=_state2.moving,verifying=_state2.verifying,result=_state2.result,lastResult=_state2.lastResult,offsetXAnim=_state2.offsetXAnim;return _react2.default.createElement(_reactNative.View,{style:{width:puzzleWidth},__source:{fileName:_jsxFileName,lineNumber:234}},_react2.default.createElement(_reactNative.View,{style:[_styles2.default.puzzleContainer,{height:puzzleHeight,opacity:displayType==='triggered'?moving||lastResult===false?1:0:1},displayType==='triggered'?_extends({},_reactNative.StyleSheet.absoluteFillObject,{top:-(puzzleHeight+20)}):_styles2.default.puzzleContainerEmbedded],__source:{fileName:_jsxFileName,lineNumber:235}},useDefault?_react2.default.createElement(_reactNative.Image,{source:defaultPuzzle.puzzle,style:[_reactNative.StyleSheet.absoluteFill,{zIndex:2},_styles2.default.image],resizeMode:'cover',__source:{fileName:_jsxFileName,lineNumber:248}}):_react2.default.createElement(_reactNativeCachedImage.CachedImage,{source:puzzle,style:[_reactNative.StyleSheet.absoluteFill,{zIndex:2},_styles2.default.image],resizeMode:'cover',__source:{fileName:_jsxFileName,lineNumber:254}}),_react2.default.createElement(_reactNative.Animated.View,{style:[_styles2.default.absoluteFill,{zIndex:3,transform:[{translateX:offsetXAnim},{perspective:1000}]}],__source:{fileName:_jsxFileName,lineNumber:260}},useDefault?_react2.default.createElement(_reactNative.Image,{source:defaultPuzzle.puzzlePiece,style:{width:puzzlePieceWidth,height:puzzleHeight},resizeMode:'cover',__source:{fileName:_jsxFileName,lineNumber:274}}):_react2.default.createElement(_reactNativeCachedImage.CachedImage,{source:puzzlePiece,style:{width:puzzlePieceWidth,height:puzzleHeight},resizeMode:'cover',__source:{fileName:_jsxFileName,lineNumber:280}})),showRefresh&&_react2.default.createElement(_reactNative.TouchableOpacity,{onPress:refresh,activeOpacity:0.7,style:_styles2.default.refresh,disabled:verifying,__source:{fileName:_jsxFileName,lineNumber:288}},_react2.default.createElement(_Ionicons2.default,{name:'ios-refresh',size:35,color:'white',__source:{fileName:_jsxFileName,lineNumber:294}}))),_react2.default.createElement(_reactNative.View,{style:_styles2.default.slideBox,__source:{fileName:_jsxFileName,lineNumber:299}},_react2.default.createElement(_reactNative.Animated.View,{style:[_styles2.default.slideIndicator,{width:offsetXAnim,borderColor:slideStatus.borderColor,backgroundColor:slideStatus.indicatorColor}],__source:{fileName:_jsxFileName,lineNumber:300}}),_react2.default.createElement(_reactNative.Animated.View,_extends({style:[_styles2.default.slider,{width:puzzlePieceWidth,backgroundColor:slideStatus.buttonColor,borderColor:slideStatus.borderColor,transform:[{translateX:offsetXAnim},{perspective:1000}]}]},this.panResponder.panHandlers,{__source:{fileName:_jsxFileName,lineNumber:311}}),verifying?_react2.default.createElement(_reactNative.ActivityIndicator,{color:'white',__source:{fileName:_jsxFileName,lineNumber:323}}):slideStatus.icon),!moving&&result===null&&_react2.default.createElement(_reactNative.Text,{style:_styles2.default.slideTips,__source:{fileName:_jsxFileName,lineNumber:325}},slideTips)));}}]);return SlideVerification;}(_react.Component);SlideVerification.propTypes={useDefault:_propTypes2.default.bool,imageSize:_propTypes2.default.shape({puzzleWidth:_propTypes2.default.number,puzzleHeight:_propTypes2.default.number,puzzlePieceWidth:_propTypes2.default.number}),displayType:_propTypes2.default.string,slideTips:_propTypes2.default.string,showRefresh:_propTypes2.default.bool,puzzle:_propTypes2.default.oneOfType([_propTypes2.default.shape({uri:_propTypes2.default.string}),_propTypes2.default.number]),puzzlePiece:_propTypes2.default.oneOfType([_propTypes2.default.shape({uri:_propTypes2.default.string}),_propTypes2.default.number]),onVerifyPassed:_propTypes2.default.func,onVerifyFailed:_propTypes2.default.func,slideVerify:_propTypes2.default.func,refresh:_propTypes2.default.func};SlideVerification.defaultProps={useDefault:false,imageSize:{puzzleWidth:300,puzzleHeight:150,puzzlePieceWidth:50},displayType:'triggered',showRefresh:false,slideTips:'向右滑动左侧箭头填充拼图',puzzle:null,puzzlePiece:null,onVerifyPassed:function onVerifyPassed(){},onVerifyFailed:function onVerifyFailed(){},slideVerify:function slideVerify(){},refresh:function refresh(){}};exports.default=SlideVerification;